﻿@using ChartJs.Blazor.Charts
@using ChartJs.Blazor.ChartJS.BarChart
@using ChartJs.Blazor.ChartJS.BarChart.Axes
@using ChartJs.Blazor.ChartJS.Common.Axes
@using ChartJs.Blazor.ChartJS.Common.Axes.Ticks
@using ChartJs.Blazor.ChartJS.Common.Properties
@using ChartJs.Blazor.ChartJS.Common.Wrappers
@using ChartJs.Blazor.Util

<div>
    <div>
        <ChartJsBarChart @ref="_barChartJs" Config="@_config" Width="@ChartWidth" Height="@ChartHeigth" />
    </div>
</div>



@code {
    private BarConfig _config;
    private ChartJsBarChart _barChartJs;
    private BarDataset<DoubleWrapper> _barDataSet;

    [Parameter]
    public int ChartWidth { get; set; } = 700;
    [Parameter]
    public int ChartHeigth { get; set; } = 1000;
    [Parameter]
    public bool IsDisplayTitle { get; set; } = true;
    [Parameter]
    public string ChartTitle { get; set; } = "";
    [Parameter]
    public bool IsResponsive { get; set; } = true;
    [Parameter]
    public bool IsAnimateRotate { get; set; } = true;
    [Parameter]
    public bool IsAnimateScale { get; set; } = true;
    [Parameter]
    public List<ChartDataItem> ChartDataList { get; set; }
    [Parameter]
    public int BorderWidth { get; set; } = 0;
    [Parameter]
    public string BorderColor { get; set; } = "#ffffff";
    [Parameter]
    public int HoverBorderWidth { get; set; } = 1;
    [Parameter]
    public string HoverBorderColor { get; set; } = ColorUtil.RandomColorString();
    [Parameter]
    public string HoverBackgroundColor { get; set; } = ColorUtil.RandomColorString();


    protected override void OnInitialized()
    {
        _config = new BarConfig
        {
            Options = new BarOptions
            {
                Title = new OptionsTitle
                {
                    Display = this.IsDisplayTitle,
                    Text = this.ChartTitle
                },
                Responsive = this.IsResponsive,
                Scales = new BarScales
                {
                    XAxes = new List<CartesianAxis>
                    {
                        new BarCategoryAxis
                        {
                            BarPercentage = 0.5,
                            BarThickness = BarThickness.Flex
                        }
                    },
                    YAxes = new List<CartesianAxis>
                    {
                        new BarLinearCartesianAxis
                        {
                            Ticks = new LinearCartesianTicks
                            {
                                BeginAtZero = true
                            }
                        }
                    }
                }
            }
        };


        _config.Data.Labels.AddRange(ChartDataList.Select(x => x.LabelName).ToArray());

        _barDataSet = new BarDataset<DoubleWrapper>
        {
            Label = "",
            BackgroundColor = ChartDataList.Select(x => ColorUtil.FromDrawingColor(x.Color)).ToArray(),
            BorderWidth = this.BorderWidth,
            HoverBackgroundColor = this.HoverBackgroundColor,
            HoverBorderColor = this.HoverBorderColor,
            HoverBorderWidth = this.HoverBorderWidth,
            BorderColor = this.BorderColor
        };

        _barDataSet.AddRange(ChartDataList.Select(x => x.Value).ToArray().Wrap());
        _config.Data.Datasets.Add(_barDataSet);

        StateHasChanged();
    }

}
